// REMEMBER TO MANUALLY SET IP ADDRESS FOR PACARANA!


import oscP5.*;
import netP5.*;

OscP5 oscP5;
NetAddress kymaAddress, maxAddress, myReceiveAddress;

OSC_received osc_received;

void setup() {
  size(400,400);
  frameRate(25);
  /* start oscP5, listening for incoming messages at port 8000 */
  oscP5 = new OscP5(this,8000);

  kymaAddress = new NetAddress("169.254.84.80", 8000); // NEED TO MANUALLY CHANGE THIS!
  maxAddress = new NetAddress("127.0.0.1", 8000);
  myReceiveAddress = new NetAddress("127.0.0.1",8000);

  osc_received = new OSC_received();
  osc_received.OSC_Setup();

  OscMessage connectMessage = new OscMessage("/osc/respond_to"); // initialize communication with Kyma
  connectMessage.add(8000);
  oscP5.send(connectMessage, kymaAddress); // send the message

  OscMessage fader1Message = new OscMessage("/1/fader1"); // initialize communication with Kyma parameter !osc_1_fader1
  fader1Message.add(0.1);
  oscP5.send(fader1Message, kymaAddress); // send the message

  OscMessage fader2Message = new OscMessage("/fader2"); // initialize communication with Kyma parameter !osc_fader2
  fader2Message.add(0.1);
  oscP5.send(fader2Message, kymaAddress); // send the message
  
  OscMessage randMessage = new OscMessage("/randomFromKyma"); // initialize communication with Kyma parameter !osc_rand
  randMessage.add(0.1);
  oscP5.send(randMessage, kymaAddress); // send the message

  OscMessage randomMessage = new OscMessage("/randomFromProcessing"); // initialize communication with Kyma parameter !osc_random
  float randomFloat = random(0.0, 1.0);
  randomMessage.add(randomFloat);
  oscP5.send(randomMessage, kymaAddress); // send the message

}


void draw() {
  background(0); 
  osc_received.oscPrint(); // demonstrate that the patch is receiving OSC from Kyma
}

void mousePressed() { // mouse press on window generates a random value for Kyma parameter !osc_random
  
  OscMessage randomMessage = new OscMessage("/randomFromProcessing");
  float test = random(0.0, 1.0);
  randomMessage.add(test);
  oscP5.send(randomMessage, kymaAddress); // send the message
}


/* incoming osc message are forwarded to the oscEvent method. */
void oscEvent(OscMessage theOscMessage) {
  /* print the address pattern and the typetag of the received OscMessage */
  //  print("### received an osc message.");
  //  print(" addrpattern: "+theOscMessage.addrPattern());
  //  println(" typetag: "+theOscMessage.typetag());
}


